
/*  Inicio Creacion de Procedimientos */

SET ECHO ON;
/*
    NOMBRE:  SP_SFACTURA
    TABLA:   T_FACTURA, T_DETALLE
    PARAMETROS ENTRADA: PNRO (NRO DE FACTURA) CUANDO ES NULL TRAE TODAS LAS
                        FACTURAS. CUANDO ES DISTINTO DE NULL TRAE ESA FACTURA.
    PARAMETROS SALIDA: NRO,FECHA,ITEM,IDART,CANTIDAD,PRECIO,ST,MONTO
    PROCESO: SELECT PROCEDURE QUE GENERA NUMEROS DE ITEMS, CALCULA SUBTOTAL
             Y CALCULA TOTAL DE FACTURA
*/
SET ECHO OFF;
SET TERM !! ;
CREATE PROCEDURE SP_SFACTURA (
   PNRO INTEGER
) RETURNS ( NRO INTEGER,
        FECHA DATE,
        ITEM INTEGER, -- CONTADOR DE ITEMS 1 .. N
        IDART INTEGER,
        CANTIDAD INTEGER,
        PRECIO DOUBLE PRECISION,
        ST DOUBLE PRECISION,
        ACUMULADO DOUBLE PRECISION,
        MONTO DOUBLE PRECISION )
   AS
   BEGIN
      IF ( PNRO IS NULL ) THEN BEGIN 
         FOR SELECT NRO,FECHA FROM T_FACTURA INTO :NRO,:FECHA DO BEGIN
            SELECT SUM(CANTIDAD*PRECIO) FROM T_DETALLE WHERE NRO = :NRO INTO :MONTO;
            ACUMULADO = 0;
            ITEM = 0;
            FOR SELECT IDART,CANTIDAD,PRECIO FROM T_DETALLE 
                WHERE NRO = :NRO INTO :IDART,:CANTIDAD,:PRECIO DO BEGIN
                ST = CANTIDAD * PRECIO;
                ACUMULADO = ACUMULADO + ST;
                ITEM = ITEM + 1;
                -- YA TENGO CARGADA UNA TUPLA, AHORA LA DEVUELVO
                SUSPEND;
            END
         END
      END ELSE BEGIN
         FOR SELECT NRO,FECHA FROM T_FACTURA WHERE NRO = :PNRO INTO :NRO,:FECHA DO BEGIN
            SELECT SUM(CANTIDAD*PRECIO) FROM T_DETALLE WHERE NRO = :NRO INTO :MONTO;
            ACUMULADO = 0;
            ITEM = 0;
            FOR SELECT IDART,CANTIDAD,PRECIO FROM T_DETALLE 
                WHERE NRO = :NRO INTO :IDART,:CANTIDAD,:PRECIO DO BEGIN
                ST = CANTIDAD * PRECIO;
                ACUMULADO = ACUMULADO + ST;
                ITEM = ITEM + 1;
                -- YA TENGO CARGADA UNA TUPLA, AHORA LA DEVUELVO
                SUSPEND;
            END
         END
      END
   END !!
SET TERM ; !!

SHOW PROCEDURES;

SET ECHO ON;

/*  Fin Creacion de procedures */
