#!/bin/bash
# ==========================================================
# UNLu
# Departamento de Ciencias Basicas
# Division Estadistica y Sistemas
# Licenciatura en Sistemas de Informacion
# 11411 - Base de Datos
# ==========================================================
#
# Descripcion:
# Script para chequear proyecto de tp final (nombres,cantidad,modelo logico)
# Ejecuta los scripts sql: check.sql y checkddl.sql
#
# Debe estar instalado isql-fb 
# Parametros:
# ==========================================================
# $1 indica usuario administrador
# $2 indica pwd     usuario administrador
# $3 indica bd a utilizar ([server:] + path + filename)
# $4 indica el rol a utilizar
# ==========================================================
#
# Atte. Guillermo Cherencio
# ==========================================================
#
if [ $# -ne 4 ]; then
    FILE=$0
    if [ -f "$FILE" ]; then 
        cat $FILE.txt
    fi
else
    echo "INICIO TEST" > ../logs/check.txt
    PROYECTO=`ls ../..`
    echo "proyecto = $PROYECTO" >> ../logs/check.txt 
    # esta RTRIM definida?
    rm -f ../logs/checkfunex.txt 
    echo "SET ECHO OFF;" > ../logs/checkfun.sql
    echo "SHOW FUNCTION RTRIM;" >> ../logs/checkfun.sql
    isql-fb -u $1 -p $2 $3 -r $4 -o ../logs/checkfunex.txt -i ../logs/checkfun.sql
    rm -f ../logs/checkfun.sql
    DEFINIDA=`grep "Function RTRIM:" ../logs/checkfunex.txt`
    rm -f ../logs/checkfunex.txt
    # creo rtrim,p_modelo_logico ejecuto p_modelo_logico,borro p_modelo_logico
    rm -f ../logs/checkddl.txt
    isql-fb -u $1 -p $2 $3 -r $4 -o ../logs/checkddl.txt -i checkddl.sql
    #elimino los titulos y los espacios adicionales al final de cada linea debido a la salida de isql-fb
    cat ../logs/checkddl.txt | awk -F" " '{ if ( $1 != "RELACION" && substr($1,1,1) != "=") { gsub(" ","",$2); print $1 " " $2; } else if (substr($1,1,1) == "=") { print "Tabla (atributos) (constraints)";print "==============================="; } }' > ../logs/checkddl2.txt
    rm -f ../logs/checkddl.txt
    mv -f ../logs/checkddl2.txt ../logs/checkddl.txt
    # si no estaba previamente definida RTRIM, la borro
    if [ "$DEFINIDA" != "Function RTRIM:" ]; then
       rm -f ../logs/checkdelfun.txt
       echo "SET ECHO OFF;" > ../logs/checkdelfun.sql
       echo "DROP EXTERNAL FUNCTION RTRIM;" >> ../logs/checkdelfun.sql
       echo "SHOW FUNCTIONS;" >> ../logs/checkdelfun.sql
       isql-fb -u $1 -p $2 $3 -r $4 -o ../logs/checkdelfun.txt -i ../logs/checkdelfun.sql
       rm -f ../logs/checkdelfun.sql
       rm -f ../logs/checkdelfun.txt
    fi
    # busco nombres incorrectos, conteo de objetos Ok
    isql-fb -u $1 -p $2 $3 -r $4 -o ../logs/check.txt -i check.sql
    # agrego consulta  modelo logico
    echo "Inicio Modelo Logico" >> ../logs/check.txt
    cat ../logs/checkddl.txt >> ../logs/check.txt
    rm -f ../logs/checkddl.txt
    echo "Fin Modelo Logico" >> ../logs/check.txt
    echo "FIN TEST" >> ../logs/check.txt
    echo  >> ../logs/check.txt
    echo "Atte. Lic. Guillermo Cherencio" >> ../logs/check.txt
    echo "UNLu - Depto. Cs. Basicas - Div. Est.y Sistemas - 11411 Base de Datos" >> ../logs/check.txt
    nano ../logs/check.txt
fi

