#!/bin/bash
# ==========================================================
# UNLu
# Departamento de Ciencias Basicas
# Division Estadistica y Sistemas
# Licenciatura en Sistemas de Informacion
# 11411 - Base de Datos
# ==========================================================
#
# Descripcion:
# Script de creacion de b.d. 
# Debe estar instalado isql-fb 
# Parametros:
# ==========================================================
# $1 indica usuario administrador
# $2 indica pwd     usuario administrador
# $3 indica bd a utilizar ([server:] + path + filename)
# $4 indica rol de usuario administrador
# ==========================================================
#
# Ariel Condo
# Ezequiel Chan
# Tomas Delvechio
#
# Integrantes del Grupo de Usuarios de Software Libre de la
# Universidad Nacional de Luján :: UNLUX ::
# ==========================================================
# G. Cherencio agregado de rol 
# ==========================================================

if [ $# -ne 4 ] 
then
    FILE=$0
    if [ -f "$FILE" ]; then 
        cat $FILE.txt
    fi
else
    FILE='../logs/database.txt'
    if [ -f "$FILE" ]; then
        if [ -w "$FILE" ]; then
            rm "$FILE" > /dev/null
        fi
    fi

    #
    # Creo script para crear base de datos $3
    #
    echo '/*'                                               >  ../scripts/ddl/create/database.sql
    echo 'Script Generico para Creacion de Base de Datos'   >> ../scripts/ddl/create/database.sql
    echo 'Script creado por '$0                             >> ../scripts/ddl/create/database.sql
    echo '*/'                                               >> ../scripts/ddl/create/database.sql
    echo ''                                                 >> ../scripts/ddl/create/database.sql
    echo 'SET AUTODDL ON;'                                  >> ../scripts/ddl/create/database.sql
    echo 'SET echo ON;'                                     >> ../scripts/ddl/create/database.sql
    echo 'CREATE DATABASE "'$3'";'                            >> ../scripts/ddl/create/database.sql
    echo 'SHOW DATABASE;'                                   >> ../scripts/ddl/create/database.sql
    echo 'EXIT;'                                            >> ../scripts/ddl/create/database.sql

    isql-fb -u $1 -p $2 -r $4 -i ../scripts/ddl/create/database.sql -o $FILE -m 
    nano $FILE
fi

