/*

Control de nombres incorrectos (imprime aquellos nombres que no estan acorde con el standard
propuesto) y conteo de objectos con nombres correctos

Atte. Guillermo Cherencio
*/
SET ECHO OFF;

select 'Busco Nombres Incorrectos' from rdb$database;

-- dominios
select distinct 'DOM' AS "Objeto",rdb$field_name as "Nombre Erroneo" from rdb$fields where rdb$field_name NOT LIKE 'RDB%' and rdb$field_name NOT LIKE 'DOM_%'
union -- generators
select distinct 'GEN',RDB$GENERATOR_NAME from RDB$GENERATORS where RDB$GENERATOR_NAME NOT LIKE 'RDB%' and RDB$GENERATOR_NAME NOT LIKE 'SQL$%' and RDB$GENERATOR_NAME NOT LIKE 'GN_%'
union -- tablas
select distinct 'TBL',RDB$RELATION_NAME from RDB$RELATIONS where RDB$SYSTEM_FLAG = 0 and RDB$VIEW_SOURCE IS NULL and RDB$RELATION_NAME NOT LIKE 'T_%'
union --indices (claves secundarias)
select distinct 'IDX',RDB$INDEX_NAME from RDB$INDICES 
where (RDB$INDEX_NAME NOT LIKE 'RDB%' and  RDB$INDEX_NAME NOT LIKE 'PK_%' and  
       RDB$INDEX_NAME NOT LIKE 'AK_%' and  RDB$INDEX_NAME NOT LIKE 'FK_%' and  
       RDB$INDEX_NAME NOT LIKE 'IDX_%');

-- vistas
select distinct 'VIEW' AS "Objeto",RDB$RELATION_NAME as "Nombre Erroneo" from RDB$RELATIONS where RDB$VIEW_SOURCE IS NOT NULL and RDB$RELATION_NAME NOT LIKE 'V_%';

-- procedimientos
select distinct 'PRO' AS "Objeto",RDB$PROCEDURE_NAME as "Nombre Erroneo" from RDB$PROCEDURES where RDB$PROCEDURE_NAME NOT LIKE 'P_%'
union -- triggers
select distinct 'TRG',RDB$TRIGGER_NAME from RDB$TRIGGERS where RDB$SYSTEM_FLAG = 0 and RDB$TRIGGER_NAME NOT LIKE 'RDB%' and not (
             RDB$TRIGGER_NAME = ('TRG_BI' || RDB$RELATION_NAME) OR RDB$TRIGGER_NAME = ('TRG_AI' || RDB$RELATION_NAME) OR 
             RDB$TRIGGER_NAME = ('TRG_BD' || RDB$RELATION_NAME) OR RDB$TRIGGER_NAME = ('TRG_AD' || RDB$RELATION_NAME) OR 
             RDB$TRIGGER_NAME = ('TRG_BU' || RDB$RELATION_NAME) OR RDB$TRIGGER_NAME = ('TRG_AU' || RDB$RELATION_NAME) );

-- exceptions
select distinct 'EX' AS "Objeto",RDB$EXCEPTION_NAME as "Nombre Erroneo" from RDB$EXCEPTIONS where RDB$EXCEPTION_NAME NOT LIKE 'EX_%';

select 'Fin Busco Nombres Incorrectos' from rdb$database;
select 'Conteo de Objectos con Nombres Correctos' from rdb$database;

-- dominios
select '# DOM' as "Objeto (Ok)",count(*) as "Cantidad" from rdb$fields where rdb$field_name LIKE 'DOM_%'
union -- generators
select '# GEN',count(*) from RDB$GENERATORS where RDB$GENERATOR_NAME LIKE 'GN_%'
union -- tablas
select '# TBL',count(*) from RDB$RELATIONS where RDB$SYSTEM_FLAG = 0 and RDB$VIEW_SOURCE IS NULL and RDB$RELATION_NAME LIKE 'T_%'
union --indices
select distinct '# IDX',count(*) from RDB$INDICES where RDB$INDEX_NAME LIKE 'IDX_%';

-- vistas
select distinct '# VIEW' as "Objeto (Ok)",count(*) as "Cantidad" from RDB$RELATIONS where RDB$SYSTEM_FLAG = 0 and RDB$VIEW_SOURCE IS NOT NULL and RDB$RELATION_NAME LIKE 'V_%';

-- procedimientos
select distinct '# PRO' as "Objeto (Ok)",count(*) as "Cantidad" from RDB$PROCEDURES where RDB$PROCEDURE_NAME LIKE 'P_%'
union -- triggers
select distinct '# TRG',count(*) from RDB$TRIGGERS where RDB$TRIGGER_NAME LIKE 'TRG_%' and (
             RDB$TRIGGER_NAME = ('TRG_BI' || RDB$RELATION_NAME) OR RDB$TRIGGER_NAME = ('TRG_AI' || RDB$RELATION_NAME) OR 
             RDB$TRIGGER_NAME = ('TRG_BD' || RDB$RELATION_NAME) OR RDB$TRIGGER_NAME = ('TRG_AD' || RDB$RELATION_NAME) OR 
             RDB$TRIGGER_NAME = ('TRG_BU' || RDB$RELATION_NAME) OR RDB$TRIGGER_NAME = ('TRG_AU' || RDB$RELATION_NAME) );

-- exceptions
select distinct '# EX' as "Objeto (Ok)",count(*) as "Cantidad" from RDB$EXCEPTIONS where RDB$EXCEPTION_NAME LIKE 'EX_%';

-- funciones (no tiene control de nombrado)
select distinct '# FUN' as "Objeto (Ok)",count(*) as "Cantidad" from RDB$FUNCTIONS where RDB$SYSTEM_FLAG IS NULL OR RDB$SYSTEM_FLAG = 0;

--pk constraints
select distinct '# PK' as "Objeto (Ok)",count(*) as "Cantidad" from RDB$INDICES where RDB$UNIQUE_FLAG = 1 and RDB$INDEX_NAME LIKE 'PK_%' and  RDB$INDEX_NAME  = ('PK_' || RDB$RELATION_NAME)
union --ak constraints
select distinct '# AK',count(*) from RDB$INDICES where RDB$UNIQUE_FLAG = 1 and RDB$INDEX_NAME LIKE 'AK_%' 
union --fk constraints
select distinct '# FK',count(*) from RDB$INDICES where RDB$INDEX_NAME LIKE 'FK_%' 
union --ck constraints
select distinct '# CK',count(*) from RDB$RELATION_CONSTRAINTS where RDB$CONSTRAINT_NAME LIKE 'CK_%';

--roles
select distinct '# ROL' as "Objeto (Ok)",count(*) as "Cantidad" from RDB$ROLES;

select 'Fin Conteo de Objectos con Nombres Correctos' from rdb$database;
SET ECHO ON;
