/*

Crea, ejecuta y destruye procedimiento P_MODELO_LOGICO que imprime el modelo
logico del sistema implementado, similar a lo escrito luego del pasaje a tablas
Deja -en forma residual- a la funcion RTRIM()

Lic. Guillermo Cherencio
*/
SET ECHO OFF;

DROP PROCEDURE P_MODELO_LOGICO;

DROP EXTERNAL FUNCTION RTRIM;

DECLARE EXTERNAL FUNCTION RTRIM CSTRING(80) RETURNS CSTRING(80) FREE_IT
  ENTRY_POINT 'IB_UDF_rtrim' MODULE_NAME 'ib_udf';

SET TERM !! ;
CREATE PROCEDURE P_MODELO_LOGICO
   RETURNS (TABLA CHAR(32),
            ATRIBUTOS VARCHAR(500)) 
   AS
      DECLARE VARIABLE COLUMNA VARCHAR(32);
      DECLARE VARIABLE TIPO VARCHAR(32);
      DECLARE VARIABLE TABLA_REF VARCHAR(32);
      DECLARE VARIABLE COLUMNA_REF VARCHAR(32);
      DECLARE VARIABLE ATRIBUTOS_REF VARCHAR(200);
      DECLARE VARIABLE N SMALLINT;
      DECLARE VARIABLE I SMALLINT;
      DECLARE VARIABLE NN SMALLINT;
      DECLARE VARIABLE II SMALLINT;
   BEGIN
      FOR select distinct RDB$RELATION_NAME 
          from RDB$RELATIONS 
          where RDB$SYSTEM_FLAG = 0 and RDB$VIEW_SOURCE IS NULL and RDB$RELATION_NAME LIKE 'T_%'
          INTO :TABLA DO BEGIN
             ATRIBUTOS='(';
             I=0;
             select distinct count(*) from RDB$RELATION_FIELDS
             where RDB$SYSTEM_FLAG = 0 and RDB$RELATION_NAME = :TABLA INTO :N;
             FOR select distinct RTRIM(RDB$FIELD_NAME)
             from RDB$RELATION_FIELDS
             where RDB$SYSTEM_FLAG = 0 and RDB$RELATION_NAME = :TABLA
             order by RDB$FIELD_POSITION ASC
             INTO :COLUMNA DO BEGIN 
                I=I+1;
                ATRIBUTOS = ATRIBUTOS || COLUMNA;
                IF ( I < N ) THEN  ATRIBUTOS = ATRIBUTOS || ','; 
                ELSE ATRIBUTOS = ATRIBUTOS || ')';
             END
             select count(*)
             from RDB$RELATION_CONSTRAINTS
             where RDB$RELATION_NAME = :TABLA AND 
                       ( RDB$CONSTRAINT_NAME LIKE 'PK_%' OR RDB$CONSTRAINT_NAME LIKE 'FK_%' OR
                         RDB$CONSTRAINT_NAME LIKE 'AK_%' OR RDB$CONSTRAINT_NAME LIKE 'CK_%')
             INTO :NN; 
             II=0;
             FOR select distinct RTRIM(RDB$CONSTRAINT_NAME),RTRIM(RDB$CONSTRAINT_TYPE)
             from RDB$RELATION_CONSTRAINTS
             where RDB$RELATION_NAME = :TABLA AND 
                       ( RDB$CONSTRAINT_NAME LIKE 'PK_%' OR RDB$CONSTRAINT_NAME LIKE 'FK_%' OR
                         RDB$CONSTRAINT_NAME LIKE 'AK_%' OR RDB$CONSTRAINT_NAME LIKE 'CK_%')
             order by RDB$CONSTRAINT_TYPE ASC
             INTO :COLUMNA,:TIPO DO BEGIN 
                II=II+1;
                ATRIBUTOS = ATRIBUTOS || COLUMNA ;
                IF ( TIPO = 'PRIMARY KEY' ) THEN ATRIBUTOS = ATRIBUTOS || '(PK';
                ELSE IF ( TIPO = 'UNIQUE' ) THEN ATRIBUTOS = ATRIBUTOS || '(AK';
                ELSE IF ( TIPO = 'FOREIGN KEY' ) THEN BEGIN
                   select RTRIM(rdb$foreign_key) 
                   from rdb$indices where rdb$index_name = :COLUMNA INTO :TABLA_REF;
                   ATRIBUTOS = ATRIBUTOS || '(FK->' || TABLA_REF ;
                END 
                --busco atributos de PK,AK,FK
                select count(*) from  rdb$index_segments 
                        where rdb$index_name = :COLUMNA into :N;
                I=0;
                ATRIBUTOS_REF='(';
                FOR select RTRIM(rdb$field_name) from  rdb$index_segments 
                        where rdb$index_name = :COLUMNA order by rdb$field_position ASC into :COLUMNA_REF DO BEGIN
                   I=I+1;
                   ATRIBUTOS_REF = ATRIBUTOS_REF || COLUMNA_REF;
                   IF ( I < N ) THEN  ATRIBUTOS_REF = ATRIBUTOS_REF || ','; 
                   ELSE ATRIBUTOS_REF = ATRIBUTOS_REF || ')';
                END 
                IF ( II < NN ) THEN ATRIBUTOS = ATRIBUTOS || ATRIBUTOS_REF || '),';
                ELSE ATRIBUTOS = ATRIBUTOS || ATRIBUTOS_REF || ')';
                --omito informacion de check constraints
                --ELSE IF ( TIPO = 'CHECK' ) THEN ATRIBUTOS = ATRIBUTOS || '(CK) ';
             END
             SUSPEND;
      END
   END !!
SET TERM ; !!

SELECT TABLA AS "RELACION",ATRIBUTOS AS "ATRIBUTOS" FROM P_MODELO_LOGICO;

DROP PROCEDURE P_MODELO_LOGICO;

SET ECHO ON;
