#!/bin/bash
# ==========================================================
# UNLu
# Departamento de Ciencias Basicas
# Division Estadistica y Sistemas
# Licenciatura en Sistemas de Informacion
# 11411 - Base de Datos
# ==========================================================
#
# Descripcion:
# Script de destruccion de b.d. 
# Debe estar instalado isql-fb 
# Parametros:
# ==========================================================
# $1 indica usuario administrador
# $2 indica pwd     usuario administrador
# $3 indica bd a utilizar ([server:] + path + filename)
# $4 indica rol de usuario administrador
# ==========================================================
#
# Ariel Condo
# Ezequiel Chan
# Tomas Delvechio
#
# Integrantes del Grupo de Usuarios de Software Libre de la
# Universidad Nacional de Luján :: UNLUX ::
# ==========================================================
# G. Cherencio agregado rol de usuario administrador
# ==========================================================

if [ $# -ne 4 ]; then
    FILE=$0
    if [ -f "$FILE" ]; then 
        cat $FILE.txt
    fi
else
    echo "Este script destruira la base de datos "$3
    echo "Presione cualquier tecla para continuar o Ctrl-C para abortar"

    read -p "" CONTINUAR

    FILE='../logs/database_del.txt'    
    if [ -f "$FILE" ]; then
        if [ -w "$FILE" ]; then
            rm "$FILE" > /dev/null
        fi
    fi
    #
    # Creo script para borrar base de datos $3
    # 
    echo "/*                                                  "        > ../scripts/ddl/drop/database.sql
    echo "Script Generico para Destruccion de Base de Datos   "       >> ../scripts/ddl/drop/database.sql
    echo "Script creado por $0                                "       >> ../scripts/ddl/drop/database.sql
    echo "*/                                                  "       >> ../scripts/ddl/drop/database.sql
    echo "SET AUTODDL ON;                                     "       >> ../scripts/ddl/drop/database.sql
    echo "SET ECHO ON;                                        "       >> ../scripts/ddl/drop/database.sql
    echo "DROP DATABASE;                                      "       >> ../scripts/ddl/drop/database.sql
    echo "SHOW DATABASE;                                      "       >> ../scripts/ddl/drop/database.sql
    echo "EXIT;                                               "       >> ../scripts/ddl/drop/database.sql
    
    isql-fb -u $1 -p $2 -r $4 -i ../scripts/ddl/drop/database.sql -o $FILE -m $3 > $FILE 2>&1
    nano $FILE
fi

